import _slicedToArray from "babel-runtime/helpers/slicedToArray";
import _classCallCheck from "babel-runtime/helpers/classCallCheck";
import _createClass from "babel-runtime/helpers/createClass";
import _possibleConstructorReturn from "babel-runtime/helpers/possibleConstructorReturn";
import _inherits from "babel-runtime/helpers/inherits";
import _typeof from "babel-runtime/helpers/typeof";
import _extends from "babel-runtime/helpers/extends";
var __rest = this && this.__rest || function (s, e) {
    var t = {};
    for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
    }if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
        if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
    }return t;
};
import React, { Component } from "react";
import { Table } from "antd";
import { wrapTooltip, insertIndexAsKey } from "./../__util";
export var mapColumns = function mapColumns() {
    var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    return columns.map(function (column) {
        var _column$tooltip = column.tooltip,
            tooltip = _column$tooltip === undefined ? false : _column$tooltip,
            renderTooltip = column.renderTooltip,
            width = column.width,
            render = column.render;

        if (!tooltip) return column;
        if (!width) throw new Error("Ops, width is required when you need wrap tooltip!");
        return _extends({}, column, {
            render: wrapTooltip({
                maxWidth: Number(width) - 20,
                preRender: render,
                renderTooltip: renderTooltip
            })
        });
    });
};
export var scrollX = function scrollX(props) {
    var _props$columns = props.columns,
        columns = _props$columns === undefined ? [] : _props$columns,
        rowSelection = props.rowSelection,
        expandedRowRender = props.expandedRowRender;

    var hasFixedColumn = columns.some(function (_ref) {
        var fixed = _ref.fixed;
        return !!fixed;
    });
    if (!hasFixedColumn) return;
    var hasCheckbox = false;
    if ((typeof rowSelection === "undefined" ? "undefined" : _typeof(rowSelection)) == "object" && rowSelection) hasCheckbox = true;
    var initalWidth = 0;
    if (hasCheckbox) initalWidth += 62;
    if (typeof expandedRowRender == "function") initalWidth += 50;
    var unFixedColumnWidthSum = columns.reduce(function (widthSum, _ref2) {
        var _ref2$width = _ref2.width,
            width = _ref2$width === undefined ? 0 : _ref2$width;
        return widthSum + Number(width);
    }, initalWidth);
    // console.log(unFixedColumnWidthSum);
    return unFixedColumnWidthSum;
};
export var RTable = function (_Component) {
    _inherits(RTable, _Component);

    function RTable() {
        _classCallCheck(this, RTable);

        return _possibleConstructorReturn(this, (RTable.__proto__ || Object.getPrototypeOf(RTable)).apply(this, arguments));
    }

    _createClass(RTable, [{
        key: "render",
        value: function render() {
            var _a = this.props,
                _a$fixedMaxWidth = _a.fixedMaxWidth,
                fixedMaxWidth = _a$fixedMaxWidth === undefined ? false : _a$fixedMaxWidth,
                style = _a.style,
                columns = _a.columns,
                pagination = _a.pagination,
                scroll = _a.scroll,
                others = __rest(_a, ["fixedMaxWidth", "style", "columns", "pagination", "scroll"]);
            var rest = others;
            if (!others.rowKey) {
                rest = _extends({}, rest, {
                    dataSource: insertIndexAsKey(others.dataSource)
                });
            }
            if (!pagination) {
                rest = _extends({}, rest, {
                    pagination: pagination
                });
            }
            var xWidth = scrollX(this.props);
            var defaultStyle = fixedMaxWidth ? { maxWidth: xWidth || "100%" } : {};
            return React.createElement(Table, _extends({ style: _extends({}, style, defaultStyle), size: "middle", columns: mapColumns(columns), pagination: _extends({ showSizeChanger: true, pageSizeOptions: ["10", "20", "50", "100", "500", "1000"], showQuickJumper: true, showTotal: function showTotal(total, _ref3) {
                        var _ref4 = _slicedToArray(_ref3, 2),
                            start = _ref4[0],
                            end = _ref4[1];

                        return start + "-" + end + " / " + total;
                    } }, pagination), scroll: _extends({ x: xWidth }, scroll) }, rest));
        }
    }]);

    return RTable;
}(Component);
export default RTable;