"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.RTable = exports.scrollX = exports.mapColumns = undefined;

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _antd = require("antd");

var _util = require("./../__util");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var __rest = undefined && undefined.__rest || function (s, e) {
    var t = {};
    for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
    }if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
        if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
    }return t;
};
var mapColumns = exports.mapColumns = function mapColumns() {
    var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    return columns.map(function (column) {
        var _column$tooltip = column.tooltip,
            tooltip = _column$tooltip === undefined ? false : _column$tooltip,
            renderTooltip = column.renderTooltip,
            width = column.width,
            render = column.render;

        if (!tooltip) return column;
        if (!width) throw new Error("Ops, width is required when you need wrap tooltip!");
        return (0, _extends3["default"])({}, column, {
            render: (0, _util.wrapTooltip)({
                maxWidth: Number(width) - 20,
                preRender: render,
                renderTooltip: renderTooltip
            })
        });
    });
};
var scrollX = exports.scrollX = function scrollX(props) {
    var _props$columns = props.columns,
        columns = _props$columns === undefined ? [] : _props$columns,
        rowSelection = props.rowSelection,
        expandedRowRender = props.expandedRowRender;

    var hasFixedColumn = columns.some(function (_ref) {
        var fixed = _ref.fixed;
        return !!fixed;
    });
    if (!hasFixedColumn) return;
    var hasCheckbox = false;
    if ((typeof rowSelection === "undefined" ? "undefined" : (0, _typeof3["default"])(rowSelection)) == "object" && rowSelection) hasCheckbox = true;
    var initalWidth = 0;
    if (hasCheckbox) initalWidth += 62;
    if (typeof expandedRowRender == "function") initalWidth += 50;
    var unFixedColumnWidthSum = columns.reduce(function (widthSum, _ref2) {
        var _ref2$width = _ref2.width,
            width = _ref2$width === undefined ? 0 : _ref2$width;
        return widthSum + Number(width);
    }, initalWidth);
    // console.log(unFixedColumnWidthSum);
    return unFixedColumnWidthSum;
};

var RTable = exports.RTable = function (_Component) {
    (0, _inherits3["default"])(RTable, _Component);

    function RTable() {
        (0, _classCallCheck3["default"])(this, RTable);
        return (0, _possibleConstructorReturn3["default"])(this, (RTable.__proto__ || Object.getPrototypeOf(RTable)).apply(this, arguments));
    }

    (0, _createClass3["default"])(RTable, [{
        key: "render",
        value: function render() {
            var _a = this.props,
                _a$fixedMaxWidth = _a.fixedMaxWidth,
                fixedMaxWidth = _a$fixedMaxWidth === undefined ? false : _a$fixedMaxWidth,
                style = _a.style,
                columns = _a.columns,
                pagination = _a.pagination,
                scroll = _a.scroll,
                others = __rest(_a, ["fixedMaxWidth", "style", "columns", "pagination", "scroll"]);
            var rest = others;
            if (!others.rowKey) {
                rest = (0, _extends3["default"])({}, rest, {
                    dataSource: (0, _util.insertIndexAsKey)(others.dataSource)
                });
            }
            if (!pagination) {
                rest = (0, _extends3["default"])({}, rest, {
                    pagination: pagination
                });
            }
            var xWidth = scrollX(this.props);
            var defaultStyle = fixedMaxWidth ? { maxWidth: xWidth || "100%" } : {};
            return _react2["default"].createElement(_antd.Table, (0, _extends3["default"])({ style: (0, _extends3["default"])({}, style, defaultStyle), size: "middle", columns: mapColumns(columns), pagination: (0, _extends3["default"])({ showSizeChanger: true, pageSizeOptions: ["10", "20", "50", "100", "500", "1000"], showQuickJumper: true, showTotal: function showTotal(total, _ref3) {
                        var _ref4 = (0, _slicedToArray3["default"])(_ref3, 2),
                            start = _ref4[0],
                            end = _ref4[1];

                        return start + "-" + end + " / " + total;
                    } }, pagination), scroll: (0, _extends3["default"])({ x: xWidth }, scroll) }, rest));
        }
    }]);
    return RTable;
}(_react.Component);

exports["default"] = RTable;